// _VF[_[̓
struct VS_INPUT
{
	float3 Position        : POSITION ;		// W( [J )
	float3 Normal          : NORMAL0 ;      // @( [J )
	float4 Diffuse         : COLOR0 ;       // fBt[YJ[
	float4 Specular        : COLOR1 ;       // XyLJ[
	float4 TexCoords0      : TEXCOORD0 ;	// eNX`W
} ;

// _VF[_[̏o
struct VS_OUTPUT
{
	float4 Diffuse         : COLOR0 ;
	float4 Specular        : COLOR1 ;
	float2 TexCoords0      : TEXCOORD0 ;
	float4 Position        : SV_POSITION ;	// W( vWFNV )
} ;


// }eAp[^
struct DX_D3D11_CONST_MATERIAL
{
	float4		Diffuse ;				// fBt[YJ[
	float4		Specular ;				// XyLJ[
	float4		Ambient_Emissive ;		// }eAG~bVuJ[ + }eAArGgJ[ * O[oArGgJ[

	float		Power ;					// XyL̋
	float		TypeParam0 ;			// }eA^Cvp[^0
	float		TypeParam1 ;			// }eA^Cvp[^1
	float		TypeParam2 ;			// }eA^Cvp[^2
} ;

// tHOp[^
struct DX_D3D11_VS_CONST_FOG
{
	float		LinearAdd ;				// tHOpp[^ end / ( end - start )
	float		LinearDiv ;				// tHOpp[^ -1  / ( end - start )
	float		Density ;				// tHOpp[^ density
	float		E ;						// tHOpp[^ Rΐ̒

	float4		Color ;					// J[
} ;

// Cgp[^
struct DX_D3D11_CONST_LIGHT
{
	int			Type ;					// Cg^Cv( DX_LIGHTTYPE_POINT Ȃ )
	int3		Padding1 ;				// pfBOP

	float3		Position ;				// W( r[ )
	float		RangePow2 ;				// L̂Q

	float3		Direction ;				// ( r[ )
	float		FallOff ;				// X|bgCgpFallOff

	float3		Diffuse ;				// fBt[YJ[
	float		SpotParam0 ;			// X|bgCgpp[^O( cos( Phi / 2.0f ) )

	float3		Specular ;				// XyLJ[
	float		SpotParam1 ;			// X|bgCgpp[^P( 1.0f / ( cos( Theta / 2.0f ) - cos( Phi / 2.0f ) ) )

	float4		Ambient ;				// ArGgJ[ƃ}eÃArGgJ[Z

	float		Attenuation0 ;			// ɂ錸pp[^O
	float		Attenuation1 ;			// ɂ錸pp[^P
	float		Attenuation2 ;			// ɂ錸pp[^Q
	float		Padding2 ;				// pfBOQ
} ;

// sNZVF[_[E_VF[_[ʃp[^
struct DX_D3D11_CONST_BUFFER_COMMON
{
	DX_D3D11_CONST_LIGHT		Light[ 6 ] ;			// Cgp[^
	DX_D3D11_CONST_MATERIAL		Material ;				// }eAp[^
	DX_D3D11_VS_CONST_FOG		Fog ;					// tHOp[^
} ;

// {p[^
struct DX_D3D11_VS_CONST_BUFFER_BASE
{
	float4		AntiViewportMatrix[ 4 ] ;				// A`r[|[gs
	float4		ProjectionMatrix[ 4 ] ;					// r[@@vWFNVs
	float4		ViewMatrix[ 3 ] ;						// [h@@r[s
	float4		LocalWorldMatrix[ 3 ] ;					// [J@@[hs

	float4		ToonOutLineSize ;						// gD[̗֊s̑傫
	float		DiffuseSource ;							// fBt[YJ[( 0.0f:}eA  1.0f:_ )
	float		SpecularSource ;						// XyLJ[(   0.0f:}eA  1.0f:_ )
	float		MulSpecularColor ;						// XyLJ[lɏZl( XyLŎgp )
	float		Padding ;
} ;

// ̑̍s
struct DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX
{
	float4		ShadowMapLightViewProjectionMatrix[ 3 ][ 4 ] ;			// VhE}bvp̃Cgr[sƃCgˉesZ
	float4		TextureMatrix[ 3 ][ 2 ] ;								// eNX`Wps
} ;

// _VF[_[EsNZVF[_[ʃp[^
cbuffer cbD3D11_CONST_BUFFER_COMMON					: register( b0 )
{
	DX_D3D11_CONST_BUFFER_COMMON				g_Common ;
} ;

// {p[^
cbuffer cbD3D11_CONST_BUFFER_VS_BASE				: register( b1 )
{
	DX_D3D11_VS_CONST_BUFFER_BASE				g_Base ;
} ;

// ̑̍s
cbuffer cbD3D11_CONST_BUFFER_VS_OTHERMATRIX			: register( b2 )
{
	DX_D3D11_VS_CONST_BUFFER_OTHERMATRIX		g_OtherMatrix ;
} ;


// main֐
VS_OUTPUT main( VS_INPUT VSInput )
{
	VS_OUTPUT VSOutput ;
	float4 lLocalPosition ;
	float4 lWorldPosition ;
	float4 lViewPosition ;
	float3 lWorldNrm ;
	float3 lViewNrm ;
	float3 lLightHalfVec ;
	float4 lLightLitParam ;
	float4 lLightLitDest ;
	float3 lLightDir ;
	float3 lLightTemp ;
	float lLightDistancePow2 ;
	float lLightGen ;
	float lLightDirectionCosA ;


	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// [JW̃Zbg
	lLocalPosition.xyz = VSInput.Position ;
	lLocalPosition.w = 1.0f ;

	// [JW[hWɕϊ
	lWorldPosition.x = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 0 ] ) ;
	lWorldPosition.y = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 1 ] ) ;
	lWorldPosition.z = dot( lLocalPosition, g_Base.LocalWorldMatrix[ 2 ] ) ;
	lWorldPosition.w = 1.0f ;

	// [hWr[Wɕϊ
	lViewPosition.x = dot( lWorldPosition, g_Base.ViewMatrix[ 0 ] ) ;
	lViewPosition.y = dot( lWorldPosition, g_Base.ViewMatrix[ 1 ] ) ;
	lViewPosition.z = dot( lWorldPosition, g_Base.ViewMatrix[ 2 ] ) ;
	lViewPosition.w = 1.0f ;

	// r[WˉeWɕϊ
	VSOutput.Position.x = dot( lViewPosition, g_Base.ProjectionMatrix[ 0 ] ) ;
	VSOutput.Position.y = dot( lViewPosition, g_Base.ProjectionMatrix[ 1 ] ) ;
	VSOutput.Position.z = dot( lViewPosition, g_Base.ProjectionMatrix[ 2 ] ) ;
	VSOutput.Position.w = dot( lViewPosition, g_Base.ProjectionMatrix[ 3 ] ) ;

	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )



	// Cg̏ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// @r[Ԃ̊pxɕϊ =====================================================( Jn )

	// [JxNg[hxNgɕϊ
	lWorldNrm.x = dot( VSInput.Normal, g_Base.LocalWorldMatrix[ 0 ].xyz ) ;
	lWorldNrm.y = dot( VSInput.Normal, g_Base.LocalWorldMatrix[ 1 ].xyz ) ;
	lWorldNrm.z = dot( VSInput.Normal, g_Base.LocalWorldMatrix[ 2 ].xyz ) ;

	// [hxNgr[xNgɕϊ
	lViewNrm.x = dot( lWorldNrm, g_Base.ViewMatrix[ 0 ].xyz ) ;
	lViewNrm.y = dot( lWorldNrm, g_Base.ViewMatrix[ 1 ].xyz ) ;
	lViewNrm.z = dot( lWorldNrm, g_Base.ViewMatrix[ 2 ].xyz ) ;

	// @r[Ԃ̊pxɕϊ =====================================================( I )


	// CgxNǧvZ
	lLightDir = normalize( lViewPosition.xyz - g_Common.Light[ 0 ].Position.xyz ) ;


	// EX|bgCglvZ ===================================================( Jn )

	// vZ ------------------

	// _ƃCgʒuƂ̋̓߂
	lLightTemp = lViewPosition.xyz - g_Common.Light[ 0 ].Position.xyz ;
	lLightDistancePow2 = dot( lLightTemp, lLightTemp ) ;

	// ̌vZ lLightGen = 1 / ( l0 + l1 *  + l2 * (  *  ) )
	lLightGen = 1.0f / ( g_Common.Light[ 0 ].Attenuation0 + g_Common.Light[ 0 ].Attenuation1 * sqrt( lLightDistancePow2 ) + g_Common.Light[ 0 ].Attenuation2 * lLightDistancePow2 ) ;

	// --------------------------------


	// X|bgCgvZ --------

	// CgxNgƃCgʒu璸_ʒuւ̃xNg̓(  Cos a )vZ 
	lLightDirectionCosA = dot( lLightDir, g_Common.Light[ 0 ].Direction ) ;

	// X|bgCgvZ  pow( falloff, ( ( Cos a - Cos f ) / ( Cos q - Cos f ) ) )
	lLightGen *= saturate( pow( abs( max( lLightDirectionCosA - g_Common.Light[ 0 ].SpotParam0, 0.0f ) * g_Common.Light[ 0 ].SpotParam1 ), g_Common.Light[ 0 ].FallOff ) ) ;

	// --------------------------------


	// LO猸őɂ鏈
	lLightGen *= step( lLightDistancePow2, g_Common.Light[ 0 ].RangePow2 ) ;

	// EX|bgCglvZ ===================================================( I )


	// CgfBt[YJ[ƃCgXyLJ[̊pxvZ ===================( Jn )

	// @ƃCg̋txNgƂ̓ς lLightLitParam.x ɃZbg
	lLightLitParam.x = dot( lViewNrm, -lLightDir ) ;

	// n[txNǧvZ norm( ( norm( _ʒu王_ւ̃xNg ) + Cg̕ ) )
	lLightHalfVec = normalize( normalize( -lViewPosition.xyz ) - lLightDir ) ;

	// @ƃn[txNg̓ς lLightLitParam.y ɃZbg
	lLightLitParam.y = dot( lLightHalfVec, lViewNrm ) ;

	// XyL˗ lLightLitParam.w ɃZbg
	lLightLitParam.w = g_Common.Material.Power ;

	// Cgp[^vZ
	lLightLitDest = lit( lLightLitParam.x, lLightLitParam.y, lLightLitParam.w ) ;

	// CgfBt[YJ[ƃCgXyLJ[̊pxvZ ===================( I )

	// Cg̏ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )



	// o̓p[^Zbg ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// fBt[YJ[ =
	//            l *
	//            ( fBt[YpxvZ *
	//              Cg̃fBt[YJ[ *
	//              }eÃfBt[YJ[ +
	//              Cg̃ArGgJ[ƃ}eÃArGgJ[Z ) +
	//            }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z
	VSOutput.Diffuse.xyz = lLightGen * ( lLightLitDest.y * g_Common.Light[ 0 ].Diffuse * g_Common.Material.Diffuse.xyz + g_Common.Light[ 0 ].Ambient.xyz ) + g_Common.Material.Ambient_Emissive.xyz ;

	// fBt[YAt@̓}eÃfBt[YJ[̃At@̂܂܎g
	VSOutput.Diffuse.w = g_Common.Material.Diffuse.w ;

	// XyLJ[ = l * XyLpxvZ * Cg̃XyLJ[ * }eÃXyLJ[
	VSOutput.Specular.xyz = lLightGen * lLightLitDest.z * g_Common.Light[ 0 ].Specular * g_Common.Material.Specular.xyz ;

	// XyLAt@̓}eÃXyLJ[̃At@̂܂܎g
	VSOutput.Specular.w = g_Common.Material.Specular.w ;


	// eNX`Wϊsɂϊsʂ̃eNX`WZbg
	VSOutput.TexCoords0.x = dot( VSInput.TexCoords0, g_OtherMatrix.TextureMatrix[ 0 ][ 0 ] ) ;
	VSOutput.TexCoords0.y = dot( VSInput.TexCoords0, g_OtherMatrix.TextureMatrix[ 0 ][ 1 ] ) ;

	// o̓p[^Zbg ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )


	// o̓p[^Ԃ
	return VSOutput ;
}

